Package org.apache.commons.beanutils

## Class ResultSetDynaClass

- java.lang.Object
- - org.apache.commons.beanutils.ResultSetDynaClass

All Implemented Interfaces:
  `java.io.Serializable`, `DynaClass`

    public class ResultSetDynaClass
    extends java.lang.Object
    implements DynaClass

Implementation of `DynaClass` for DynaBeans that wrap the `java.sql.Row` objects of a `java.sql.ResultSet`. The normal usage pattern is something like:

       ResultSet rs = ...;
       ResultSetDynaClass rsdc = new ResultSetDynaClass(rs);
       Iterator rows = rsdc.iterator();
       while (rows.hasNext())  {
         DynaBean row = (DynaBean) rows.next();
         ... process this row ...
       }
       rs.close();

Each column in the result set will be represented as a DynaBean property of the corresponding name (optionally forced to lower case for portability).

WARNING - Any `DynaBean` instance returned by this class, or from the `Iterator` returned by the `iterator()` method, is directly linked to the row that the underlying result set is currently positioned at. This has the following implications:

- Once you retrieve a different `DynaBean` instance, you should no longer use any previous instance.
- Changing the position of the underlying result set will change the data that the `DynaBean` references.
- Once the underlying result set is closed, the `DynaBean` instance may no longer be used.

Any database data that you wish to utilize outside the context of the current row of an open result set must be copied. For example, you could use the following code to create standalone copies of the information in a result set:

       ArrayList results = new ArrayList(); // To hold copied list
       ResultSetDynaClass rsdc = ...;
       DynaProperty[] properties = rsdc.getDynaProperties();
       BasicDynaClass bdc =
         new BasicDynaClass("foo", BasicDynaBean.class,
                            rsdc.getDynaProperties());
       Iterator rows = rsdc.iterator();
       while (rows.hasNext()) {
         DynaBean oldRow = (DynaBean) rows.next();
         DynaBean newRow = bdc.newInstance();
         PropertyUtils.copyProperties(newRow, oldRow);
         results.add(newRow);
       }

Version:
  $Id$
See Also:
  Serialized Form

### Field Summary

Fields
`protected boolean` `lowerCase` Flag defining whether column names should be lower cased when converted to property names.
`protected DynaProperty[]` `properties` The set of dynamic properties that are part of this `DynaClass`.
`protected java.util.Map<java.lang.String,​DynaProperty>` `propertiesMap` The set of dynamic properties that are part of this `DynaClass`, keyed by the property name.
`protected java.sql.ResultSet` `resultSet` The `ResultSet` we are wrapping.

### Constructor Summary

Constructors
`ResultSetDynaClass​(java.sql.ResultSet resultSet)` Construct a new ResultSetDynaClass for the specified `ResultSet`.
`ResultSetDynaClass​(java.sql.ResultSet resultSet, boolean lowerCase)` Construct a new ResultSetDynaClass for the specified `ResultSet`.
`ResultSetDynaClass​(java.sql.ResultSet resultSet, boolean lowerCase, boolean useColumnLabel)` Construct a new ResultSetDynaClass for the specified `ResultSet`.

### Method Summary

All Methods Instance Methods Concrete Methods
`protected DynaProperty` `createDynaProperty​(java.sql.ResultSetMetaData metadata, int i)` Factory method to create a new DynaProperty for the given index into the result set metadata.
`protected java.lang.String` `getColumnName​(java.lang.String name)` Get the table column name for the specified property name.
`DynaProperty[]` `getDynaProperties()` Return an array of `ProperyDescriptors` for the properties currently defined in this DynaClass.
`DynaProperty` `getDynaProperty​(java.lang.String name)` Return a property descriptor for the specified property, if it exists; otherwise, return `null`.
`java.lang.String` `getName()` Return the name of this DynaClass (analogous to the `getName()` method of `java.lang.Class</code), which allows the same <code>DynaClass` implementation class to support different dynamic classes, with different sets of properties.
`protected java.lang.Object` `getObject​(java.sql.ResultSet resultSet, java.lang.String name)` Get a column value from a `ResultSet` for the specified name.
`java.lang.Object` `getObjectFromResultSet​(java.lang.String name)` Get a value from the `ResultSet` for the specified property name.
`protected void` `introspect​(java.sql.ResultSet resultSet)` Introspect the metadata associated with our result set, and populate the `properties` and `propertiesMap` instance variables.
`java.util.Iterator<DynaBean>` `iterator()` Return an `Iterator` of `DynaBean` instances for each row of the wrapped `ResultSet`, in "forward" order.
`protected java.lang.Class<?>` `loadClass​(java.lang.String className)` Loads the class of the given name which by default uses the class loader used to load this library.
`DynaBean` `newInstance()` Instantiate and return a new DynaBean instance, associated with this DynaClass.
`void` `setUseColumnLabel​(boolean useColumnLabel)` Set whether the column label or name should be used for the property name.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.commons.beanutils.DynaClass

`getDynaProperties, getDynaProperty, getName, newInstance`

### Field Detail

#### resultSet

    protected java.sql.ResultSet resultSet

The `ResultSet` we are wrapping.

#### lowerCase

    protected boolean lowerCase

Flag defining whether column names should be lower cased when converted to property names.

#### properties

    protected DynaProperty[] properties

The set of dynamic properties that are part of this `DynaClass`.

#### propertiesMap

    protected java.util.Map<java.lang.String,​DynaProperty> propertiesMap

The set of dynamic properties that are part of this `DynaClass`, keyed by the property name. Individual descriptor instances will be the same instances as those in the `properties` list.

### Constructor Detail

#### ResultSetDynaClass

    public ResultSetDynaClass​(java.sql.ResultSet resultSet)
                       throws java.sql.SQLException

Construct a new ResultSetDynaClass for the specified `ResultSet`. The property names corresponding to column names in the result set will be lower cased.

Parameters:
  `resultSet` - The result set to be wrapped
Throws:
  `java.lang.NullPointerException` - if `resultSet` is `null`
  `java.sql.SQLException` - if the metadata for this result set cannot be introspected

#### ResultSetDynaClass

    public ResultSetDynaClass​(java.sql.ResultSet resultSet,
                              boolean lowerCase)
                       throws java.sql.SQLException

Construct a new ResultSetDynaClass for the specified `ResultSet`. The property names corresponding to the column names in the result set will be lower cased or not, depending on the specified `lowerCase` value.

WARNING - If you specify `false` for `lowerCase`, the returned property names will exactly match the column names returned by your JDBC driver. Because different drivers might return column names in different cases, the property names seen by your application will vary depending on which JDBC driver you are using.

Parameters:
  `resultSet` - The result set to be wrapped
  `lowerCase` - Should property names be lower cased?
Throws:
  `java.lang.NullPointerException` - if `resultSet` is `null`
  `java.sql.SQLException` - if the metadata for this result set cannot be introspected

#### ResultSetDynaClass

    public ResultSetDynaClass​(java.sql.ResultSet resultSet,
                              boolean lowerCase,
                              boolean useColumnLabel)
                       throws java.sql.SQLException

Construct a new ResultSetDynaClass for the specified `ResultSet`. The property names corresponding to the column names in the result set will be lower cased or not, depending on the specified `lowerCase` value.

WARNING - If you specify `false` for `lowerCase`, the returned property names will exactly match the column names returned by your JDBC driver. Because different drivers might return column names in different cases, the property names seen by your application will vary depending on which JDBC driver you are using.

Parameters:
  `resultSet` - The result set to be wrapped
  `lowerCase` - Should property names be lower cased?
  `useColumnLabel` - true if the column label should be used, otherwise false
Throws:
  `java.lang.NullPointerException` - if `resultSet` is `null`
  `java.sql.SQLException` - if the metadata for this result set cannot be introspected
Since:
  1.8.3

### Method Detail

#### iterator

    public java.util.Iterator<DynaBean> iterator()

Return an `Iterator` of `DynaBean` instances for each row of the wrapped `ResultSet`, in "forward" order. Unless the underlying result set supports scrolling, this method should be called only once.

Returns:
  An `Iterator` of `DynaBean` instances

#### getObjectFromResultSet

    public java.lang.Object getObjectFromResultSet​(java.lang.String name)
                                            throws java.sql.SQLException

Get a value from the `ResultSet` for the specified property name.

Parameters:
  `name` - The property name
Returns:
  The value
Throws:
  `java.sql.SQLException` - if an error occurs
Since:
  1.8.0

#### loadClass

    protected java.lang.Class<?> loadClass​(java.lang.String className)
                                    throws java.sql.SQLException

Loads the class of the given name which by default uses the class loader used to load this library. Dervations of this class could implement alternative class loading policies such as using custom ClassLoader or using the Threads's context class loader etc.

Parameters:
  `className` - The name of the class to load
Returns:
  The loaded class
Throws:
  `java.sql.SQLException` - if the class cannot be loaded

#### getName

    public java.lang.String getName()

Return the name of this DynaClass (analogous to the `getName()` method of `java.lang.Class</code), which allows the same <code>DynaClass` implementation class to support different dynamic classes, with different sets of properties.

Specified by:
  `getName` in interface `DynaClass`
Returns:
  the name of the DynaClass

#### getDynaProperty

    public DynaProperty getDynaProperty​(java.lang.String name)

Return a property descriptor for the specified property, if it exists; otherwise, return `null`.

Specified by:
  `getDynaProperty` in interface `DynaClass`
Parameters:
  `name` - Name of the dynamic property for which a descriptor is requested
Returns:
  The descriptor for the specified property
Throws:
  `java.lang.IllegalArgumentException` - if no property name is specified

#### getDynaProperties

    public DynaProperty[] getDynaProperties()

Return an array of `ProperyDescriptors` for the properties currently defined in this DynaClass. If no properties are defined, a zero-length array will be returned.

Specified by:
  `getDynaProperties` in interface `DynaClass`
Returns:
  the set of properties for this DynaClass

#### newInstance

    public DynaBean newInstance()
                         throws java.lang.IllegalAccessException,
                                java.lang.InstantiationException

Instantiate and return a new DynaBean instance, associated with this DynaClass. NOTE - This operation is not supported, and throws an exception.

Specified by:
  `newInstance` in interface `DynaClass`
Returns:
  A new `DynaBean` instance
Throws:
  `java.lang.IllegalAccessException` - if the Class or the appropriate constructor is not accessible
  `java.lang.InstantiationException` - if this Class represents an abstract class, an array class, a primitive type, or void; or if instantiation fails for some other reason

#### setUseColumnLabel

    public void setUseColumnLabel​(boolean useColumnLabel)

Set whether the column label or name should be used for the property name.

Parameters:
  `useColumnLabel` - true if the column label should be used, otherwise false

#### createDynaProperty

    protected DynaProperty createDynaProperty​(java.sql.ResultSetMetaData metadata,
                                              int i)
                                       throws java.sql.SQLException

Factory method to create a new DynaProperty for the given index into the result set metadata.

Parameters:
  `metadata` - is the result set metadata
  `i` - is the column index in the metadata
Returns:
  the newly created DynaProperty instance
Throws:
  `java.sql.SQLException` - If an error occurs accessing the SQL metadata

#### introspect

    protected void introspect​(java.sql.ResultSet resultSet)
                       throws java.sql.SQLException

Introspect the metadata associated with our result set, and populate the `properties` and `propertiesMap` instance variables.

Parameters:
  `resultSet` - The `resultSet` whose metadata is to be introspected
Throws:
  `java.sql.SQLException` - if an error is encountered processing the result set metadata

#### getObject

    protected java.lang.Object getObject​(java.sql.ResultSet resultSet,
                                         java.lang.String name)
                                  throws java.sql.SQLException

Get a column value from a `ResultSet` for the specified name.

Parameters:
  `resultSet` - The result set
  `name` - The property name
Returns:
  The value
Throws:
  `java.sql.SQLException` - if an error occurs

#### getColumnName

    protected java.lang.String getColumnName​(java.lang.String name)

Get the table column name for the specified property name.

Parameters:
  `name` - The property name
Returns:
  The column name (which can be different if the lowerCase option is used).